/*
	csw-icontextblock-counter.js
   	
	Version: [2018-01-18 1:15]
*/

//var cswIconCounterMutationObservers = [];
var cswIconCounterInstances = [];


function cswAddMutationObserver( target, child )
{
	// only set observer for hidden items
	if( jQuery(target).css('display') == 'none' )
	{
      // create an observer for this hidden element       
		var observer = cswCreateObserver() ;
		//cswIconCounterMutationObservers.push({ child: child, obj:observer });
					
		// var target = document.querySelector(el);
		observer.observe( target.get(0), { attributes: true } );				
	}
}
             
function cswCreateObserver()
{
	var observer = new MutationObserver(function(mutations) {
                      cswCheckInstances(true);				
						});
                  
   return observer;
}  

function cswCheckInstances(initOnce)
{
   initOnce = typeof initOnce !== 'undefined' ? initOnce : false;
   
   // loop over all Instances and check any are no longer hidden
   // If visible, init them and remove from array
   for( var i=0; i < cswIconCounterInstances.length; i=i+1 )
   {
      var obj = cswIconCounterInstances[i];
      var isVisible = jQuery('.' + obj.className).is(':visible');

      if( isVisible )
      {
         if( obj.init == 0 )
         {
          
            // init the object
            initIconCounterInstance(obj.className,obj.delay,obj.time);
         
            updateInstanceNode(obj, 1);
         }
      }
      else
      {
         if ( !initOnce ) 
            updateInstanceNode(obj, 0);
      }
   }
} 

function hasInstanceNode(obj) {
   var index = cswIconCounterInstances.indexOf(obj);

   if (index !== -1)  
      return true;
   else
      return false; 
}

function updateInstanceNode( obj, value) {
   var index = cswIconCounterInstances.indexOf(obj);
   
  if ( !hasInstanceNode(obj) ) 
  {
      obj.init = value;
      
      addInstanceNode(obj);
  }
  else
  {
      cswIconCounterInstances[index].init = value;
  }
}

function addInstanceNode(obj) {
   var index = cswIconCounterInstances.indexOf(obj);

  if ( !hasInstanceNode(obj) ) 
      cswIconCounterInstances.push(obj);
}
                  

function initIconCounter( className, delay, time )
{
   // If in CS UI, wait until it is fully loaded as we insert elements into DOM
   if( jsPageSessionContributeMode == 'author' || jsPageSessionContributeMode == 'edit' || jsPageSessionContributeMode == 'approve' )
   {
      if( typeof cs_pageReady === 'function' && cs_pageReady() == false )
      {
         // UI Still initializing, so call ourself again
         setTimeout( 
            function() {
               initIconCounter(className, delay, time); 
            }, 50 );
      }
   }

   setTimeout( 
      function() {
         initIconCounterMeat(className, delay, time);
      }, 100 );
}



function initIconCounterMeat(className,delay,time) {
   var currSelector = jQuery('.' + className);
   var firstSelector = currSelector.filter(":first");
   var isVisible = firstSelector.is(':visible');
 
   // If Hidden, Create Observer to process later
   if( isVisible == false )
   {
      
      // save off the args, init = 0
      var obj = { 
                  init: 0,
                  className: className,
                  delay: delay, 
                  time: time 
               };
               
      // add to array as an Uninitialized Instances
      addInstanceNode(obj);
      //cswIconCounterInstances.push(obj);
             
      // setup an observer for each hidden parent element 
      // if the element changes then well check each read more instance that has not been initialled 
      // to see if it is no longer hidden
      firstSelector.parents().each(function(){ 
         cswAddMutationObserver( jQuery(this), firstSelector );  
      });
      
   }
   else
   {
     // save off the args, init = 1   
      var obj = { 
            init: 1,
            className: className,
            delay: delay, 
            time: time 
         };
         
      // add to array as an initialized Instances
      addInstanceNode(obj);
      //cswIconCounterInstances.push(obj); 
      
      // It's visible so Init it   
      initIconCounterInstance( className, delay, time);
   }
}


function initIconCounterInstance( className, delay, time) {
   var currSelector = jQuery('.' + className);
   currSelector.counterUp({
                   delay: delay,
                   time: time
               });
}